"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const api_1 = require("../api");
class ClientNavigation {
    clearNavigationHistory() {
        this.navigationHistory = [];
    }
    addStepTONavigationHistory(stepId) {
        this.navigationHistory = [...this.navigationHistory, stepId];
    }
    backInNavigationHistory() {
        var _a, _b;
        return (_b = (_a = this.navigationHistory) === null || _a === void 0 ? void 0 : _a.pop()) !== null && _b !== void 0 ? _b : null;
    }
    hasBackNavigation() {
        this.navigationHistory.length > 1;
    }
    constructor(httpClient, sessionStorage) {
        this.responseBuffer = new api_1.Response();
        this.navigationHistory = [];
        this.httpClient = httpClient;
        this.sessionStorage = sessionStorage;
    }
    isObjectEmpty(obj) {
        for (const _ in obj) {
            return false;
        }
        return true;
    }
    getElementByKey(obj, key) {
        return obj[key];
    }
    buildResponseFromJSON(json) {
        const jsonObject = JSON.parse(json);
        const { session, currentStep, steps } = jsonObject;
        const response = {
            session,
            currentStep,
            steps,
        };
        return response;
    }
    fetchMiddleend(request) {
        return __awaiter(this, void 0, void 0, function* () {
            let crudeResponse;
            const sessionStored = String(request.session);
            if (sessionStored.length <= 0) {
                crudeResponse = yield this.httpClient.post(request);
            }
            else {
                crudeResponse = yield this.httpClient.put(request);
            }
            const response = this.buildResponseFromJSON(crudeResponse);
            this.sessionStorage.putSessionId(response.session);
            return response;
        });
    }
    navigate(connection, data, fetchingCallback, image) {
        return __awaiter(this, void 0, void 0, function* () {
            // TODO deberia recibir un objeto data en vez de output
            console.log("connection que llega: ", connection);
            console.log("output que llega: ", data);
            const shoudFetch = connection.forceSync || this.isObjectEmpty(this.responseBuffer.steps);
            console.log("el resultado es", shoudFetch);
            // If is force sync or local graph is empty should fetch middleend
            if (shoudFetch) {
                const request = new api_1.RequestData();
                request.data = data;
                request.nextStep = connection.stepTo;
                request.session = yield this.sessionStorage.getSessionId();
                if (image) {
                    request.image = image; // <- asignar imagen si se provee
                }
                fetchingCallback(true);
                this.clearNavigationHistory();
                this.responseBuffer = yield this.fetchMiddleend(request);
                fetchingCallback(false);
            }
            let stepToFindInLocalGrap;
            if (shoudFetch) {
                stepToFindInLocalGrap = this.responseBuffer.currentStep || "";
            }
            else {
                stepToFindInLocalGrap = connection.stepTo;
            }
            const response = this.getElementByKey(this.responseBuffer.steps, stepToFindInLocalGrap);
            this.addStepTONavigationHistory(connection.stepTo);
            return response;
        });
    }
    navigateBack() {
        return __awaiter(this, void 0, void 0, function* () {
            const backStepId = this.backInNavigationHistory();
            if (backStepId != null) {
                const response = this.getElementByKey(this.responseBuffer.steps, backStepId);
                return response;
            }
            else {
                throw Error("not back step to navigate");
            }
        });
    }
}
exports.default = ClientNavigation;
