"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Context = void 0;
const SessionData_1 = __importDefault(require("../contrat/SessionData"));
const StepProxy_1 = require("./StepProxy");
const DataProxy_1 = require("./DataProxy");
const RequestData_1 = require("../../api/contract/RequestData");
class Context {
    constructor(request) {
        this.requestData = RequestData_1.RequestData.TODO();
        this.component = [];
        this.dataProxy = DataProxy_1.DataProxy.TODO();
        this.session = SessionData_1.default.TODO();
        this.getDataFromSession = (key) => this.session.getData(key);
        this.setDataInSession = (key, value) => this.session.putData(key, value);
        this.removeDataInSession = (key) => this.session.removeData(key);
        this.getDataFromContext = (key) => this.dataProxy.getData(key);
        this.setDataInContext = (key, value) => this.dataProxy.putData(key, value);
        this.requestData = request;
        this.data = {};
        this.stepProxy = new StepProxy_1.StepProxy();
        this.dataProxy = new DataProxy_1.DataProxy();
    }
    getDataFromOutput(key) {
        var _a;
        const output = (_a = this.requestData.data) === null || _a === void 0 ? void 0 : _a.output;
        if (output === undefined || output === null || !(key in output)) {
            return null;
        }
        return output[key];
    }
    getDataFromQueryParam(key) {
        var _a;
        const queryParam = (_a = this.requestData.data) === null || _a === void 0 ? void 0 : _a.queryParams;
        if (queryParam === undefined || queryParam === null || !(key in queryParam)) {
            return null;
        }
        return queryParam[key];
    }
    setImage(value) {
        this.requestData.image = value;
    }
    getImage() {
        return this.requestData.image;
    }
}
exports.Context = Context;
