"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class SessionData {
    constructor() {
        this.id = "";
        this.data = {};
    }
    putData(key, value) {
        this.data = Object.assign(Object.assign({}, this.data), { [key]: value });
    }
    getData(key) {
        const data = this.data[key];
        if (data === undefined || data === null || !(key in this.data)) {
            return null;
        }
        return data;
    }
    removeData(key) {
        if (key in this.data) {
            delete this.data[key];
        }
    }
    static TODO() {
        if (!SessionData._instance) {
            SessionData._instance = new SessionData();
        }
        SessionData._instance.data = {};
        SessionData._instance.id = "dummy";
        return SessionData._instance;
    }
}
SessionData._instance = null;
exports.default = SessionData;
