"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const Bifurcation_1 = __importDefault(require("./Bifurcation"));
const context_1 = require("../context");
const api_1 = require("../../api");
describe("Bifurcation unit test", function () {
    it("test bifurcation when is executed with false condition then nex step conection is on false connection", () => __awaiter(this, void 0, void 0, function* () {
        const bifurcation = new Bifurcation_1.default();
        const trueConnection = new api_1.Connection();
        const falseConnection = new api_1.Connection();
        bifurcation.connections = {
            on_true_connection: trueConnection,
            on_false_connection: falseConnection,
        };
        const request = new api_1.RequestData();
        const context = new context_1.Context(request);
        bifurcation.condition = () => false;
        yield bifurcation.execute(context);
        assert_1.default.equal(falseConnection, bifurcation.getNexStepConnection(context));
    }));
    it("test bifurcation when is executed with true condition then nex step conection is on true connection", () => __awaiter(this, void 0, void 0, function* () {
        const bifurcation = new Bifurcation_1.default();
        const trueConnection = new api_1.Connection();
        const falseConnection = new api_1.Connection();
        bifurcation.connections = {
            on_true_connection: trueConnection,
            on_false_connection: falseConnection,
        };
        const request = new api_1.RequestData();
        const context = new context_1.Context(request);
        bifurcation.condition = () => true;
        yield bifurcation.execute(context);
        assert_1.default.equal(trueConnection, bifurcation.getNexStepConnection(context));
    }));
    it("test bifurcation when is navegated return itself", () => {
        const bifurcation = new Bifurcation_1.default();
        const nextStep = bifurcation.navigate("mock_step_id");
        assert_1.default.equal(bifurcation, nextStep);
    });
});
