"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert = __importStar(require("assert"));
const Graph_1 = __importDefault(require("./Graph"));
const ViewStep_1 = __importDefault(require("./ViewStep"));
const context_1 = require("../context");
const RequestData_1 = require("../../api/contract/RequestData");
describe('Graph unit test', () => {
    it('test nexFrom when two steps are conected then the steo one has continue connection to step two', () => {
        const request = new RequestData_1.RequestData();
        const context = new context_1.Context(request);
        const graph = new Graph_1.default();
        const node1 = new ViewStep_1.default("node_1");
        const node2 = new ViewStep_1.default("node_2");
        graph.nexFrom(node1, node2);
        assert.ok(node1.getNexStepConnection(context));
        assert.equal(node2.id, node1.getNexStepConnection(context).stepTo);
    });
    it('test linkFrom when two steps are linked then step one has connection to step two', () => {
        const graph = new Graph_1.default();
        const node1 = new ViewStep_1.default("node_1");
        const node2 = new ViewStep_1.default("node_2");
        graph.linkFrom(node1, node2, 'custom_link_id');
        const connection = node1.connections['custom_link_id'];
        assert.ok(connection);
        assert.equal(connection.stepTo, node2.id);
    });
    it('test graph when navigate to step that exist then navigation is ok', () => {
        const graph = new Graph_1.default();
        const node1 = new ViewStep_1.default("node_1");
        const node2 = new ViewStep_1.default("node_2");
        const node3 = new ViewStep_1.default("node_3");
        graph.nexFrom(node1, node2);
        graph.nexFrom(node2, node3);
        const result = graph.navigate(node3.id);
        assert.ok(result);
        assert.equal(result, node3);
    });
});
