"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Version = void 0;
const Graph_1 = __importDefault(require("../graph/Graph"));
const SessionData_1 = __importDefault(require("../contrat/SessionData"));
const api_1 = require("../../api");
class Version extends Graph_1.default {
    constructor(sessionClient) {
        super();
        this.sessionClient = sessionClient;
        this.response = {
            steps: {},
        };
    }
    addStepToResponse(viewStep, responseGraph) {
        if (responseGraph.length === 0) {
            responseGraph.push(viewStep);
        }
        else {
            const newContinue = new api_1.Connection();
            newContinue.id = "continue";
            newContinue.stepTo = viewStep.id;
            responseGraph[responseGraph.length - 1].addOrRemplaceConnection(newContinue);
            responseGraph.push(viewStep);
        }
    }
    versionNavigation(context) {
        return __awaiter(this, void 0, void 0, function* () {
            let shouldContinueNavigating = true;
            let firstStepIdToNavegate = null;
            let actualStep = context.requestData.nextStep;
            const responseGraph = [];
            while (shouldContinueNavigating) {
                const step = this.navigate(actualStep);
                if (step === null) {
                    shouldContinueNavigating = false;
                    break;
                }
                const execution = yield step.execute(context);
                if (execution !== null) {
                    this.addStepToResponse(execution, responseGraph);
                    if (firstStepIdToNavegate == null) {
                        firstStepIdToNavegate = execution.id;
                    }
                }
                const connection = step.getNexStepConnection(context);
                if (connection == undefined || connection.forceSync === true) {
                    shouldContinueNavigating = false;
                    break;
                }
                actualStep = connection.stepTo;
            }
            return [firstStepIdToNavegate !== null && firstStepIdToNavegate !== void 0 ? firstStepIdToNavegate : "", responseGraph];
        });
    }
    generateResultObject(responseGraph) {
        const objetoResultado = {};
        responseGraph.forEach((item) => {
            objetoResultado[item.id] = item;
        });
        return objetoResultado;
    }
    versionPostNavigate(context) {
        return __awaiter(this, void 0, void 0, function* () {
            var _a, _b;
            context.session = SessionData_1.default.TODO();
            const newSesion = yield this.sessionClient.createSesion();
            console.log("session id", newSesion.id);
            context.session.data = newSesion.data;
            ((_a = context.session) === null || _a === void 0 ? void 0 : _a.id) == newSesion.id;
            const response = { steps: {} };
            const [firstStepIdToNavegate, responseGraph] = yield this.versionNavigation(context);
            response.session = newSesion.id;
            response.currentStep = firstStepIdToNavegate || context.requestData.nextStep;
            yield this.sessionClient.updateSesion(newSesion.id, (_b = context.session) === null || _b === void 0 ? void 0 : _b.data);
            response.steps = this.generateResultObject(responseGraph);
            return response;
        });
    }
    versionPutNavigate(context) {
        return __awaiter(this, void 0, void 0, function* () {
            var _a, _b;
            context.session = SessionData_1.default.TODO(); // TODO remove is by default
            let actualSession = null;
            console.log("try get session -------");
            actualSession = yield this.sessionClient.getSesion(context.requestData.session);
            console.log("try get session 2 -------");
            if (actualSession == null) {
                console.log("catch get session -------");
                actualSession = yield this.sessionClient.createSesion();
                console.log("catch 2 get session -------");
            }
            console.log("session id", actualSession.id);
            context.session.data = actualSession.data;
            ((_a = context.session) === null || _a === void 0 ? void 0 : _a.id) == actualSession.id;
            const response = { steps: {} };
            const [firstStepIdToNavegate, responseGraph] = yield this.versionNavigation(context);
            response.session = actualSession.id;
            response.currentStep = firstStepIdToNavegate || context.requestData.nextStep;
            response.steps = this.generateResultObject(responseGraph);
            yield this.sessionClient.updateSesion(actualSession.id, (_b = context.session) === null || _b === void 0 ? void 0 : _b.data);
            return response;
        });
    }
}
exports.Version = Version;
