"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert = __importStar(require("assert"));
const Version_1 = require("./Version");
const ViewStep_1 = __importDefault(require("../graph/ViewStep"));
const context_1 = require("../context");
const SessionClient_1 = __importDefault(require("../contrat/SessionClient"));
const SessionData_1 = __importDefault(require("../contrat/SessionData"));
const RequestData_1 = require("../../api/contract/RequestData");
describe("Version unit test", () => {
    class SessionClientMock extends SessionClient_1.default {
        constructor() {
            super(...arguments);
            this.sessionData = new SessionData_1.default();
        }
        getSessionData() {
            this.sessionData.id = "mock_session_id";
            return this.sessionData;
        }
        createSesion() {
            return Promise.resolve(this.getSessionData());
        }
        updateSesion(id, data) {
            return __awaiter(this, void 0, void 0, function* () {
                return Promise.resolve(this.getSessionData());
            });
        }
        getSesion(id) {
            return __awaiter(this, void 0, void 0, function* () {
                return Promise.resolve(this.getSessionData());
            });
        }
    }
    it('test versionPostNavigate when navigation is executed then session, current step and steps are correct', () => __awaiter(void 0, void 0, void 0, function* () {
        const sessionClient = new SessionClientMock();
        const version = new Version_1.Version(sessionClient);
        const request = new RequestData_1.RequestData();
        request.nextStep = "node_2";
        const context = new context_1.Context(request);
        const node1 = new ViewStep_1.default("node_1");
        const node2 = new ViewStep_1.default("node_2");
        const node3 = new ViewStep_1.default("node_3");
        version.nexFrom(node1, node2);
        version.nexFrom(node2, node3);
        const response = yield version.versionPostNavigate(context);
        assert.ok(response.session);
        assert.equal("mock_session_id", response.session);
        assert.ok(response.currentStep);
        assert.equal("node_2", response.currentStep);
        assert.ok(response.steps);
        const expectedStepsId = ["node_2", "node_3"];
        assert.deepStrictEqual(expectedStepsId.sort(), Object.keys(response.steps).sort());
    }));
});
