"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Step_1 = __importDefault(require("./Step"));
class ViewStep extends Step_1.default {
    constructor(id) {
        super(id);
        this.uiType = "empty_view_step";
        this.components = [];
        this.data = {};
        this.stepObserverEvents = [];
        this.stepPostableEvents = [];
        this.backGroundColor = "#ffffff";
    }
    execute(context) {
        return __awaiter(this, void 0, void 0, function* () {
            var _a, _b, _c, _d;
            yield ((_a = this.beforeAction) === null || _a === void 0 ? void 0 : _a.call(this, context));
            yield ((_b = this.builderAction) === null || _b === void 0 ? void 0 : _b.call(this, context));
            this.components = context.stepProxy.visualComponents;
            context.stepProxy.clearComponents();
            this.stepObserverEvents = context.stepProxy.observerEvents;
            context.stepProxy.clearObserverEvent();
            this.header = context.stepProxy.header;
            (_c = context.stepProxy) === null || _c === void 0 ? void 0 : _c.clearHeader();
            yield ((_d = this.afterAction) === null || _d === void 0 ? void 0 : _d.call(this, context));
            return this;
        });
    }
    render(viewStep, nav) { }
}
exports.default = ViewStep;
